﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;

namespace Validate_AtLeast_TextBox_DataAnnotation_MVC.Models
{
    using System.Reflection;
    using System.ComponentModel.DataAnnotations;

    public class AtLeastOneRequired : ValidationAttribute
    {
        public override bool IsValid(object value)
        {
            // Get Type of value.
            Type typeInfo = value.GetType();

            // Get PropertyInfo of Type using Reflection.
            PropertyInfo[] propertyInfos = typeInfo.GetProperties();

            // Loop through PropertyInfo Array.
            foreach (PropertyInfo propertyInfo in propertyInfos)
            {
                // Check if property has value or not.
                if (propertyInfo.GetValue(value) != null)
                {
                    // Property has value.
                    return true;
                }
            }

            // All Properties are NULL.
            return false;
        }
    }
}